package io.keikai.app.ui;

import org.slf4j.*;
import org.zkoss.zk.ui.*;
import org.zkoss.zk.ui.select.SelectorComposer;
import org.zkoss.zk.ui.select.annotation.Wire;
import org.zkoss.zul.Label;

import java.util.UUID;

/**
 * Handle the error happened in an event listener.
 */
public class ErrorPageComposer extends SelectorComposer<Component> {
    private static final Logger logger = LoggerFactory.getLogger(ErrorPageComposer.class);

    @Wire
    private Label errorId;

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);
        String errorIdMessage = "The error ID: " + UUID.randomUUID();
        logger.error(errorIdMessage,
                Executions.getCurrent().getAttribute("javax.servlet.error.exception"));
        errorId.setValue(errorIdMessage);
    }
}
