/* 
	Purpose:
		
	Description:
		
	History:
		2015/1/12, Created by JerryChen

Copyright (C) 2015 Potix Corporation. All Rights Reserved.

*/
package io.keikai.app.ui.dlg;

import io.keikai.app.BookInfo;
import io.keikai.app.ui.CtrlBase;
import org.zkoss.zk.ui.*;
import org.zkoss.zk.ui.select.annotation.*;
import org.zkoss.zk.ui.util.*;
import org.zkoss.zul.*;

import java.util.Map;

/**
 * 
 * @author JerryChen
 *
 */
public class ShareBookCtrl extends CtrlBase<Window>{
	
	@Wire
	Textbox url;
	
	public ShareBookCtrl() {
		super(false);
	}

	private static final long serialVersionUID = 1L;
	
	private final static String SHARED_URL = "sharedUrl";
	private final static String URI = "~./zssapp/dlg/shareBook.zul";
	
	public static void show(BookInfo currentBookInfo) {
		Execution execution = Executions.getCurrent();
		Desktop desktop = execution.getDesktop();
		desktop.getRequestPath();
		String port = (execution.getServerPort() == 80) ? "" : (":" + execution.getServerPort());
		String url = execution.getScheme() + "://" + execution.getServerName() + port + 
				execution.getContextPath() + "?" + "file=" + currentBookInfo.getName();
		
		Map<String, Object> arg = newMap(newEntry(SHARED_URL, url));
		Window comp = (Window) Executions.createComponents(URI, null, arg);
		comp.doModal();
		return;
	}

	public void doAfterCompose(Window comp) throws Exception {
		super.doAfterCompose(comp);
		
		Map<?, ?> arg = Executions.getCurrent().getArg();
		
		String sharedUrl = (String) arg.get(SHARED_URL);
		url.setValue(sharedUrl);
		url.select();
		Clients.evalJavaScript(" document.execCommand(\"copy\");");
		Notification.show("link copied", Notification.TYPE_INFO,  url,"end_after", 3000, false);
	}
	
	@Listen("onClick=#url")
	public void onUrlClick() {
		url.select();
	}

	@Listen("onClick=#done; onOK=#shareBookDlg; onCancel=#shareBookDlg")
	public void onDone() {
		getSelf().detach();
	}
}
